{from: Alexey Monastyrenko <aamonster@mail.ru> 06.11.1997   }
{  F(x,y):=45*Sqr(Sin(x/N*10+2)/(y/N+0.5))*Sqr(Sin(y/M*5+1))}
{-----------------------------------------------------------}
uses Graph,Crt;
const W=8;
const SizeX=400;
const SizeY=170;
const CornerX=20;
const CornerY=300;
const ProfileCornerX=20;
const ProfileCornerY=470;
const MaxHeight=150;
const N=SizeX div W;
const M=SizeY div W;
var H:array[0..N,0..M] of Byte;
    C:Char;

{$L EGAVGA} { ⮡  ᪠  ᮡ egavga.bgi     }
            {  祭 䠩 egavga.obj 믮 }
            { binobj egavga.bgi egavga egavgabgi       }
procedure EGAVGABGI; external;

var
 grDriver: Integer;
 grMode: Integer;
 ErrCode: Integer;

var I,II,J,K:Integer;

begin
  grDriver := Detect;
  RegisterBGIDriver(@EGAVGABGI);
  InitGraph(grDriver, grMode,' ');
  ErrCode := GraphResult;
  if ErrCode <> grOK then begin
    WriteLn('Graphics error:', GraphErrorMsg(ErrCode));
    Halt(254);
  end;
  for J:=M downto 0 do begin
    for I:=0 to N do begin
      H[I,J]:=Round(45*Sqr(Sin(I/N*10+2)/(I/N+0.5))*Sqr(Sin(J/M*5+1))){+Random(15)};
    end;
  end;

  for J:=M downto 0 do begin
    SetColor(LightBlue);
    if J<M then
    for K:=0 to W-1 do begin
      Line(CornerX+J*W+K,CornerY-J*W-K,CornerX+N*W+J*W+K,CornerY-J*W-K);
    end;{}
    SetColor(LightBlue);
    if J<M then
      for K:=0 to W-1 do
        Line(CornerX+J*W+K,CornerY-J*W,CornerX+J*W+K,CornerY-J*W-(H[0,J]*(W-K)+(H[0,J+1]+W)*K)div W);{ ࠩ}
    for I:=0 to N-1 do begin
      SetColor(LightBlue);
      for K:=0 to W-1 do
        Line(CornerX+I*W+J*W+K,CornerY-J*W,CornerX+I*W+J*W+K,CornerY-J*W-(H[I,J]*(W-K)+H[I+1,J]*K)div W);{䨫 - }
      SetColor(White);
      Line(CornerX+I*W+J*W,CornerY-J*W-H[I,J],CornerX+I*W+J*W+W,CornerY-J*W-H[I+1,J]);{䨫 - }
      SetColor(White);
      if J<M then
        if H[I+1,J]<H[I,J+1]+W then
          Line(CornerX+I*W+J*W,CornerY-J*W-H[I,J],CornerX+I*W+(J+1)*W,CornerY-(J+1)*W-H[I,J+1]);{  䨫}
    end;
    SetColor(White);
    Line(CornerX+N*W + J*W, CornerY-J*W-H[N,J], CornerX+N*W + J*W, CornerY-J*W); {⨪  ࠢ}
{    Delay(100);}
  end;
  I:=0; J:=0;
  repeat
    SetColor(LightRed);
    Line(CornerX+N*W+J*W+5, CornerY-J*W, CornerX+N*W+J*W+20, CornerY-J*W);
    Line(CornerX+I*W-3, CornerY+3, CornerX+I*W-15, CornerY+15);

    for II:=0 to N-1 do begin
      for K:=0 to W-1 do begin
        SetColor(Black);
        Line(ProfileCornerX+II*W+K,ProfileCornerY,
             ProfileCornerX+II*W+K,ProfileCornerY-MaxHeight);{  䨫}
        SetColor(LightBlue);
        Line(ProfileCornerX+II*W+K,ProfileCornerY,
             ProfileCornerX+II*W+K,ProfileCornerY-(H[II,J]*(W-K)+H[II+1,J]*K)div W);{䨫 - }
      end;
      SetColor(White);
      Line(ProfileCornerX+II*W,ProfileCornerY-H[II,J],ProfileCornerX+II*W+W,ProfileCornerY-H[II+1,J]);{䨫 - }
    end;
    SetColor(Red);
    Line(ProfileCornerX+I*W,ProfileCornerY,
         ProfileCornerX+I*W,ProfileCornerY-H[I,J]);

    C:=ReadKey;

    SetColor(Black);
    Line(CornerX+N*W+J*W+5, CornerY-J*W, CornerX+N*W+J*W+20, CornerY-J*W);
    Line(CornerX+I*W-3, CornerY+3, CornerX+I*W-15, CornerY+15);
    case C of
      #0: case ReadKey of
            #$48: Inc(J); {up}
            #$50: Dec(J); {down}
            #$4B: Dec(I); {left}
            #$4D: Inc(I); {right}
          end;
      #27:Break;
    end;
    if J<0 then J:=0;
    if J>M then J:=M;
    if I<0 then I:=0;
    if I>N then I:=N;
  until False;
  CloseGraph;
end.