{from: Alexey Monastyrenko <aamonster@mail.ru> 23.02.1997 }
{  F(x,y)=(50*Sqr(Sin(x/9+2)/(x+10)*25)*Sqr(Sin(y/6+1)))  };
{changed by Valery Votintsev <rswag@sources.ru> :         }
{           added: CLOSEGRAPH at exit                     }
{---------------------------------------------------------}
uses Graph,Crt;
const W=6;
const V=6;
const N=400 div W;
const M=200 div V;
var H,H1:array[1..N] of Byte;

{$L EGAVGA} { ⮡  ᪠  ᮡ egavga.bgi     }
            {  祭 䠩 egavga.obj 믮 }
            { binobj egavga.bgi egavga egavgabgi       }
procedure EGAVGABGI; external;

var
 grDriver: Integer;
 grMode: Integer;
 ErrCode: Integer;

var I,J,K:Integer;

begin
  grDriver := Detect;
  RegisterBGIDriver(@EGAVGABGI);
  InitGraph(grDriver, grMode,' ');
  ErrCode := GraphResult;
  if ErrCode <> grOK then begin
    WriteLn('Graphics error:', GraphErrorMsg(ErrCode));
    Halt(254);
  end;
  for I:=1 to N do H[I]:=0;

  for J:=M downto 0 do begin
    H1:=H;
    for I:=1 to N do begin
      H[I]:=Round(50*Sqr(Sin(I/9+2)/(I+10)*25)*Sqr(Sin(J/6+1))){+Random(15)};
    end;
    SetColor(LightBlue);
    for K:=0 to V-1 do begin
      Line(20+W+J*V+K,400-J*V-K,20+N*W+J*V+K,400-J*V-K);
    end;
    SetColor(LightBlue);
    for K:=0 to V-1 do
      Line(20+W+J*V+K,400-J*V,20+W+J*V+K,400-J*V-(H[1]*(V-K)+(H1[1]+V)*K)div V);{}
    for I:=1 to N-1 do begin
      SetColor(LightBlue);
      for K:=0 to W-1 do
        Line(20+I*W+J*V+K,400-J*V,20+I*W+J*V+K,400-J*V-(H[I]*(W-K)+H[I+1]*K)div W);{}
      SetColor(White);
      Line(20+I*W+J*V,400-J*V-H[I],20+I*W+J*V+W,400-J*V-H[I+1]);{}
      SetColor(White);
      if H[I+1]<H1[I]+V then
      Line(20+I*W+J*V,400-J*V-H[I],20+I*W+(J+1)*V,400-(J+1)*V-H1[I]);{}
    end;
    SetColor(White);
    Line(20+N*W + J*V, 400-J*V-H[N], 20+N*W + J*V, 400-J*V);
{    Delay(100);}
  end;
  SetColor(White);
{  Line(20+W, 400-J*V-H[1], 20+W, 400-J*W);}
  ReadKey;
  CloseGraph;
end.